SystemOrganization addCategory: #'Pier-Security-Model'!
SystemOrganization addCategory: #'Pier-Security-Command'!
SystemOrganization addCategory: #'Pier-Security-Tests'!

PRCommand subclass: #PUChangeSecurity
	instanceVariableNames: 'with all hidden operator permissions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

PUChangeSecurity subclass: #PUChangeGroup
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PUChangeGroup class methodsFor: 'accessing-description' stamp: 'lr 2/20/2006 16:37'!
descriptionGroup
	^ (MASingleOptionDescription selector: #group label: 'Group' priority: 200)
		comment: 'Changes the group ownership to the selected group.';
		options: (MADynamicObject on: [ self groupInstances ]);
		reference: PUGroup description;
		undefined: '(unchanged)';
		beSorted;
		yourself.! !

!PUChangeGroup class methodsFor: 'testing' stamp: 'lr 12/20/2005 09:35'!
isAbstract
	^ false! !

!PUChangeGroup class methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:34'!
label
	^ 'Change Group'! !

!PUChangeGroup methodsFor: 'configuration' stamp: 'lr 2/20/2006 14:35'!
accessor
	^ MACascadeAccessor selectors: #( securityDecoration groupCommands ).! !

!PUChangeGroup methodsFor: 'events' stamp: 'lr 12/20/2005 15:53'!
doExecuteFor: aStructure
	self group notNil
		ifTrue: [ aStructure securityDecoration group: self group ].
	super doExecuteFor: aStructure.! !

!PUChangeGroup methodsFor: 'accessing' stamp: 'lr 2/20/2006 13:13'!
group
	^ group ifNil: [ group := self structure group ].! !

!PUChangeGroup methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:40'!
group: aGroup
	group := aGroup! !

PUChangeSecurity subclass: #PUChangeOther
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PUChangeOther class methodsFor: 'testing' stamp: 'lr 12/20/2005 10:33'!
isAbstract
	^ false! !

!PUChangeOther class methodsFor: 'accessing' stamp: 'lr 12/20/2005 10:32'!
label
	^ 'Change Other'! !

!PUChangeOther methodsFor: 'configuration' stamp: 'lr 2/20/2006 14:36'!
accessor
	^ MACascadeAccessor selectors: #( securityDecoration otherCommands ).! !

PUChangeSecurity subclass: #PUChangeOwner
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PUChangeOwner class methodsFor: 'accessing-description' stamp: 'lr 2/20/2006 16:36'!
descriptionOwner
	^ (MASingleOptionDescription selector: #owner label: 'Owner' priority: 200)
		comment: 'Changes the ownership to the selected user.';
		options: (MADynamicObject on: [ self userInstances ]);
		reference: PUUser description;
		undefined: '(unchanged)';
		beSorted;
		yourself.! !

!PUChangeOwner class methodsFor: 'testing' stamp: 'lr 12/20/2005 09:35'!
isAbstract
	^ false! !

!PUChangeOwner class methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:35'!
label
	^ 'Change Owner'! !

!PUChangeOwner methodsFor: 'accessing' stamp: 'lr 2/20/2006 14:37'!
accessor
	^ MACascadeAccessor selectors: #( securityDecoration ownerCommands ).! !

!PUChangeOwner methodsFor: 'events' stamp: 'lr 12/20/2005 15:53'!
doExecuteFor: aStructure
	self owner notNil
		ifTrue: [ aStructure securityDecoration owner: self owner ].
	super doExecuteFor: aStructure.! !

!PUChangeOwner methodsFor: 'accessing' stamp: 'lr 2/20/2006 13:14'!
owner
	^ owner ifNil: [ owner := self structure owner ].! !

!PUChangeOwner methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:40'!
owner: anUser
	owner := anUser! !

!PUChangeSecurity class methodsFor: 'private' stamp: 'lr 1/7/2006 14:46'!
commandClasses
	^ PRCommand withAllConcreteClasses asSet
		remove: PULogin;
		remove: PULogout;
		yourself.! !

!PUChangeSecurity class methodsFor: 'accessing-defaults' stamp: 'lr 2/20/2006 17:05'!
defaultAll
	^ true! !

!PUChangeSecurity class methodsFor: 'accessing-defaults' stamp: 'lr 2/20/2006 17:05'!
defaultHidden
	^ true! !

!PUChangeSecurity class methodsFor: 'accessing-defaults' stamp: 'lr 2/20/2006 17:07'!
defaultOperator
	^ self defaultOperators first.! !

!PUChangeSecurity class methodsFor: 'accessing-defaults' stamp: 'lr 2/20/2006 17:07'!
defaultOperators
	^ #( set add remove )! !

!PUChangeSecurity class methodsFor: 'accessing-defaults' stamp: 'lr 2/20/2006 17:09'!
defaultWith
	^ true! !

!PUChangeSecurity class methodsFor: 'accessing-description' stamp: 'lr 2/20/2006 17:05'!
descriptionAll
	^ (MABooleanDescription selector: #all label: 'Recursive' priority: 110 default: self defaultAll)
		comment: 'Apply changes recursively to all children.';
		beRequired;
		yourself.! !

!PUChangeSecurity class methodsFor: 'accessing-description' stamp: 'lr 2/20/2006 17:06'!
descriptionHidden
	^ (MABooleanDescription selector: #hidden label: 'Hidden' priority: 120 default: self defaultHidden)
		comment: 'Apply changes to hidden structures.';
		beRequired;
		yourself.! !

!PUChangeSecurity class methodsFor: 'accessing-description' stamp: 'lr 2/20/2006 17:06'!
descriptionOperator
	^ (MASingleOptionDescription selector: #operator label: 'Operator' priority: 300 default: self defaultOperator)
		comment: 'Defines if the permissions should remain unchanged, be set to the selected ones, or be added/removed from the current selection.';
		reference: MASymbolDescription new;
		options: self defaultOperators;
		undefined: '(unchanged)';
		yourself.! !

!PUChangeSecurity class methodsFor: 'accessing-description' stamp: 'lr 2/20/2006 16:31'!
descriptionPermissions
	^ (MAMultipleOptionDescription selector: #permissions label: 'Permissions' priority: 310)
		comment: 'Defines the set of permissions used together with the selected operation.';
		options: (MADynamicObject on: [ self commandClasses ]);
		reference: MAClassDescription new;
		beSorted;
		yourself.! !

!PUChangeSecurity class methodsFor: 'accessing-description' stamp: 'lr 2/20/2006 17:06'!
descriptionWith
	^ (MABooleanDescription selector: #with label: 'Current' priority: 100 default: self defaultWith)
		comment: 'Apply changes to the current structure.';
		beRequired;
		yourself.! !

!PUChangeSecurity class methodsFor: 'private' stamp: 'lr 12/23/2005 20:45'!
groupInstances
	^ PRCurrentContext value kernel groups.! !

!PUChangeSecurity class methodsFor: 'private' stamp: 'lr 12/23/2005 20:45'!
userInstances
	^ PRCurrentContext value kernel users.! !

!PUChangeSecurity methodsFor: 'accessing' stamp: 'lr 2/20/2006 14:36'!
accessor
	self subclassResponsibility! !

!PUChangeSecurity methodsFor: 'accessing-scope' stamp: 'lr 2/20/2006 17:01'!
all
	^ all ifNil: [ all := self class defaultAll ].! !

!PUChangeSecurity methodsFor: 'accessing-scope' stamp: 'lr 2/20/2006 17:01'!
all: aBoolean
	all := aBoolean! !

!PUChangeSecurity methodsFor: 'events' stamp: 'lr 2/20/2006 17:02'!
doExecute
	super doExecute.
	self structure enumerator
		with: self with; all: self all; hidden: self hidden;
		do: [ :each | self doExecuteFor: each ].! !

!PUChangeSecurity methodsFor: 'events' stamp: 'lr 2/20/2006 17:03'!
doExecuteFor: aStructure
	"Apply the changes to aStructure. Override this method to further modify aStructure. This method is automatically called by #doExecute for all the requested structure."

	self accessor 
		write: (self operator = #set 
			ifTrue: [ self permissions copy ]
			ifFalse: [
				self operator = #add
					ifTrue: [ 
						(self accessor read: aStructure) 
							copyWithAll: self permissions ]
					ifFalse: [
						self operator = #remove
							ifTrue: [ 
								(self accessor read: aStructure) 
									copyWithoutAll: self permissions ]
							ifFalse: [ ^ self ] ] ])
		to: aStructure.! !

!PUChangeSecurity methodsFor: 'accessing-scope' stamp: 'lr 2/20/2006 17:00'!
hidden
	^ hidden ifNil: [ hidden := self class defaultHidden ].! !

!PUChangeSecurity methodsFor: 'accessing-scope' stamp: 'lr 1/14/2006 17:18'!
hidden: aBoolean
	hidden := aBoolean! !

!PUChangeSecurity methodsFor: 'accessing-operation' stamp: 'lr 2/20/2006 17:21'!
operator
	^ operator! !

!PUChangeSecurity methodsFor: 'accessing-operation' stamp: 'lr 2/20/2006 16:17'!
operator: aSymbol
	operator := aSymbol! !

!PUChangeSecurity methodsFor: 'accessing-operation' stamp: 'lr 2/20/2006 16:14'!
permissions
	^ permissions ifNil: [ permissions := self accessor read: self structure ].! !

!PUChangeSecurity methodsFor: 'accessing-operation' stamp: 'lr 2/20/2006 16:25'!
permissions: aCollectionOfCommands
	permissions := aCollectionOfCommands asSet! !

!PUChangeSecurity methodsFor: 'accessing-scope' stamp: 'lr 2/20/2006 17:00'!
with
	^ with ifNil: [ with := self class defaultWith ].! !

!PUChangeSecurity methodsFor: 'accessing-scope' stamp: 'lr 2/20/2006 16:59'!
with: aBoolean
	with := aBoolean! !

PRCommand subclass: #PULogin
	instanceVariableNames: 'username password user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PULogin class methodsFor: 'accessing-description' stamp: 'lr 12/20/2005 11:44'!
descriptionPassword
	^ (MAPasswordDescription selector: #password label: 'Password' priority: 200)
		beRequired;
		yourself.! !

!PULogin class methodsFor: 'accessing-description' stamp: 'lr 12/20/2005 11:44'!
descriptionUsername
	^ (MAStringDescription selector: #username label: 'Username' priority: 100)
		beRequired;
		yourself.! !

!PULogin class methodsFor: 'testing' stamp: 'lr 12/20/2005 11:44'!
isAbstract
	^ false! !

!PULogin class methodsFor: 'testing' stamp: 'lr 12/21/2005 23:43'!
isValidIn: aContext
	^ aContext isLoggedIn not.! !

!PULogin class methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:44'!
label
	^ 'Login'! !

!PULogin methodsFor: 'events' stamp: 'lr 2/24/2006 08:54'!
doAnswer
	super doAnswer.
	self answer: (self answer user: self user).! !

!PULogin methodsFor: 'events' stamp: 'lr 2/20/2006 14:10'!
doValidate
	super doValidate.
	self user: (self kernel users
		detect: [ :each |
			each name = self username 
				and: [ each validatePassword: self password ] ]
		ifNone: [ PUInvalidLogin signal: 'Invalid username or password.' ]).! !

!PULogin methodsFor: 'testing' stamp: 'lr 12/20/2005 11:54'!
isLogged
	^ false! !

!PULogin methodsFor: 'accessing' stamp: 'lr 2/20/2006 13:11'!
password
	^ password ifNil: [ password := String new ].! !

!PULogin methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:43'!
password: aString
	password := aString! !

!PULogin methodsFor: 'private' stamp: 'lr 12/20/2005 11:53'!
user
	^ user! !

!PULogin methodsFor: 'accessing' stamp: 'lr 2/20/2006 13:11'!
username
	^ username ifNil: [ username := String new ].! !

!PULogin methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:43'!
username: aString
	username := aString! !

!PULogin methodsFor: 'private' stamp: 'lr 12/20/2005 11:53'!
user: aUser
	user := aUser! !

PRCommand subclass: #PULogout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PULogout class methodsFor: 'testing' stamp: 'lr 12/20/2005 11:56'!
isAbstract
	^ false! !

!PULogout class methodsFor: 'testing' stamp: 'lr 12/21/2005 23:43'!
isValidIn: aContext
	^ aContext isLoggedIn.! !

!PULogout class methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:56'!
label
	^ 'Logout'! !

!PULogout methodsFor: 'events' stamp: 'lr 2/20/2006 16:51'!
doExecute
	super doExecute.
	self answer: (self context user: nil).! !

!PULogout methodsFor: 'testing' stamp: 'lr 12/20/2005 11:55'!
isLogged
	^ false! !

!PULogout methodsFor: 'testing' stamp: 'lr 12/20/2005 12:13'!
isQuick
	^ true! !

PRDecoration subclass: #PUSecurity
	instanceVariableNames: 'owner ownerCommands group groupCommands otherCommands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!

!PUSecurity commentStamp: 'lr 12/20/2005 15:05' prior: 0!
Every structure is owned by a specific user. The owner of an object comprises its user class. Permissions assigned to the user class only apply to that specific user. A structure is also assigned a group, which comprises its group class. Permissions assigned to the group class only apply to members of that group. Users who are not otherwise represented by the other two classes comprise a file's others class.

The effective permissions that have applied to a specific user in relation to a file are determined in logical precedence. For example, the user who owns the file will have the effective permissions given to the user class regardless of those assigned to the group or others class.!

!PUSecurity class methodsFor: 'testing' stamp: 'lr 12/20/2005 10:26'!
isAbstract
	^ false! !

!PUSecurity class methodsFor: 'events' stamp: 'lr 2/20/2006 16:52'!
onStructureAdded: aStructure
	| decoration |
	decoration := aStructure isRoot
		ifTrue: [ aStructure securityDecorationClass new ]
		ifFalse: [ aStructure parent securityDecoration copy ].
	PRCurrentContext value ifNotNilDo: [ :context |
		decoration
			owner: context user;
			group: (context user 
				ifNotNil: [ context user group ]) ].
	^ aStructure
		addDecoration: decoration
		ifPresent: [ :value | value ].! !

!PUSecurity methodsFor: 'visiting' stamp: 'lr 12/20/2005 14:31'!
accept: aVisitor
	aVisitor visitSecurity: self.! !

!PUSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:30'!
group
	^ group! !

!PUSecurity methodsFor: 'accessing-permissions' stamp: 'lr 2/20/2006 16:04'!
groupCommands
	^ groupCommands ifNil: [ groupCommands := self ownerCommands copy ].! !

!PUSecurity methodsFor: 'accessing-permissions' stamp: 'lr 2/20/2006 16:25'!
groupCommands: aSet
	groupCommands := aSet asSet.! !

!PUSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 10:12'!
group: aGroup
	group := aGroup! !

!PUSecurity methodsFor: 'initialization' stamp: 'lr 2/20/2006 16:02'!
initialize
	super initialize.
	self ownerCommands: PRCommand withAllConcreteClasses asSet.
	self groupCommands: self ownerCommands copy.
	self otherCommands: (Array with: PRViewCommand).! !

!PUSecurity methodsFor: 'testing' stamp: 'lr 2/20/2006 16:53'!
isAllowedCommand: aCommandClass in: aContext
	(aContext user notNil and: [ aContext user isSuperuser ])
		ifTrue: [ ^ true ].
	(self owner = aContext user)
		ifTrue: [ ^ self ownerCommands includes: aCommandClass ].
	(self group notNil and: [ self group includes: aContext user ])
		ifTrue: [ ^ self groupCommands includes: aCommandClass ].
	^ self otherCommands includes: aCommandClass.! !

!PUSecurity methodsFor: 'accessing-permissions' stamp: 'lr 2/20/2006 16:04'!
otherCommands
	^ otherCommands ifNil: [ otherCommands := Set with: PRViewCommand ].! !

!PUSecurity methodsFor: 'accessing-permissions' stamp: 'lr 2/20/2006 16:25'!
otherCommands: aSet
	otherCommands := aSet asSet.! !

!PUSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 15:04'!
owner
	^ owner! !

!PUSecurity methodsFor: 'accessing-permissions' stamp: 'lr 2/20/2006 16:03'!
ownerCommands
	^ ownerCommands ifNil: [ ownerCommands := PRCommand withAllConcreteClasses asSet ].! !

!PUSecurity methodsFor: 'accessing-permissions' stamp: 'lr 2/20/2006 16:25'!
ownerCommands: aSet
	ownerCommands := aSet asSet.! !

!PUSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 15:04'!
owner: anUser
	owner := anUser! !

!PUSecurity methodsFor: 'copying' stamp: 'lr 12/20/2005 15:07'!
postCopy
	super postCopy.
	self ownerCommands: self ownerCommands copy.
	self groupCommands: self groupCommands copy.
	self otherCommands: self otherCommands copy.! !

!PUSecurity methodsFor: 'configuration' stamp: 'lr 12/20/2005 10:16'!
priority
	^ -200! !

!PRStructure class methodsFor: '*pier-security' stamp: 'lr 1/19/2006 09:43'!
descriptionGroup
	^ (MAToOneRelationDescription selector: #group label: 'Group' priority: 120)
		classes: (Array with: PUGroup);
		yourself.! !

!PRStructure class methodsFor: '*pier-security' stamp: 'lr 1/19/2006 09:43'!
descriptionOwner
	^ (MAToOneRelationDescription selector: #owner label: 'Owner' priority: 110)
		classes: (Array with: PUUser);
		yourself.! !

!PRStructure methodsFor: '*pier-security-accessing' stamp: 'lr 1/16/2006 11:05'!
group
	"Answer the owning-group of the file."

	^ self securityDecoration ifNotNilDo: [ :value | value group ].! !

!PRStructure methodsFor: '*pier-security-accessing' stamp: 'lr 1/16/2006 11:05'!
owner
	"Answer the owning-user of the receiver."
	
	^ self securityDecoration ifNotNilDo: [ :value | value owner ].! !

!PRStructure methodsFor: '*pier-security-decorations' stamp: 'lr 1/9/2006 09:13'!
securityDecoration
	^ self 
		decorationOfClass: self securityDecorationClass
		ifAbsent: [ self securityDecorationClass onStructureAdded: self ].! !

!PRStructure methodsFor: '*pier-security-decorations' stamp: 'lr 1/7/2006 14:43'!
securityDecorationClass
	^ PUSecurity! !

MADistribution subclass: #PUDistribution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!

!PUDistribution class methodsFor: 'accessing' stamp: 'lr 1/7/2006 15:08'!
package
	"The SqueakMap package name."

	^ 'Pier Unix Security'! !

!PUDistribution class methodsFor: 'accessing' stamp: 'lr 1/7/2006 14:48'!
packages
	^ #( ( 'Pier-Security' ) )! !

!PUDistribution class methodsFor: 'accessing' stamp: 'lr 1/7/2006 15:00'!
preamble
	^ '(SMSqueakMap default packageWithName: ''Pier'')
	lastRelease install.' , String cr.! !

!PUDistribution class methodsFor: 'accessing' stamp: 'lr 1/7/2006 15:09'!
version
	"The first item is the product name, which should only contain lowercase letters. Then the version numbers are following, that are made up of three numbers. An optimal suffix alpha, beta, pre or rc follows. External packages or extensions might want to call this method to check the version required to run."

	^ #( pierunixsecurity 1 0 0 alpha )! !

!PRContext methodsFor: '*pier-security-accessing' stamp: 'lr 2/20/2006 15:03'!
group
	^ self user group.! !

!PRContext methodsFor: '*pier-security-testing' stamp: 'lr 2/20/2006 16:50'!
isLoggedIn
	^ self user notNil.! !

!PRContext methodsFor: '*pier-security-initialization' stamp: 'lr 12/20/2005 12:16'!
setUser: aUser
	self propertyAt: #user put: aUser.! !

!PRContext methodsFor: '*pier-security-accessing' stamp: 'lr 2/20/2006 16:50'!
user
	^ self propertyAt: #user ifAbsentPut: [ nil ].! !

!PRContext methodsFor: '*pier-security-navigation' stamp: 'lr 2/20/2006 13:56'!
user: anUser
	"Create a copy of the current context with the current user replaced by anUser."

	^ self copy
		setUser: anUser;
		yourself.
! !

!PRVisitor methodsFor: '*pier-security-visiting-structure' stamp: 'lr 12/20/2005 14:35'!
visitSecurity: anObject
	self visitDecoration: anObject! !

PRObject subclass: #PUMember
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!

PUMember subclass: #PUGroup
	instanceVariableNames: 'users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!

!PUGroup class methodsFor: 'testing' stamp: 'lr 12/20/2005 10:14'!
isAbstract
	^ false! !

!PUGroup methodsFor: 'testing' stamp: 'lr 12/20/2005 15:13'!
includes: anUser
	^ self users includes: anUser.! !

!PUGroup methodsFor: 'initialization' stamp: 'lr 1/5/2006 13:44'!
initialize
	super initialize.
	users := OrderedCollection new.! !

!PUGroup methodsFor: 'accessing-readonly' stamp: 'lr 12/20/2005 14:51'!
users
	^ users! !

!PUMember class methodsFor: 'accessing-description' stamp: 'lr 1/19/2006 10:43'!
descriptionName
	^ (MAStringDescription accessor: (MASelectorAccessor read: #name write: #setName:) label: 'Name')
		beReadonly;
		yourself.! !

!PUMember class methodsFor: 'instance-creation' stamp: 'lr 1/5/2006 13:47'!
named: aString
	^ self new
		setName: aString;
		yourself.! !

!PUMember methodsFor: 'comparing' stamp: 'lr 1/5/2006 13:43'!
hash
	^ self class hash bitXor: self name hash.! !

!PUMember methodsFor: 'accessing' stamp: 'lr 12/20/2005 10:13'!
name
	^ name! !

!PUMember methodsFor: 'printing' stamp: 'lr 12/20/2005 10:14'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' name: '; print: self name.! !

!PUMember methodsFor: 'initialize-release' stamp: 'lr 1/5/2006 13:47'!
setName: aString
	name := aString! !

!PUMember methodsFor: 'comparing' stamp: 'lr 1/5/2006 13:43'!
= anObject
	^ self class = anObject class
		and: [ self name = anObject name ].! !

PUMember subclass: #PUUser
	instanceVariableNames: 'password groups superuser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!

!PUUser class methodsFor: 'testing' stamp: 'lr 12/20/2005 10:14'!
isAbstract
	^ false! !

!PUUser methodsFor: 'utilties' stamp: 'lr 12/20/2005 14:53'!
addGroup: aGroup
	self groups add: aGroup.
	aGroup users add: self.! !

!PUUser methodsFor: 'accessing-readonly' stamp: 'lr 1/5/2006 11:44'!
group
	^ self groups first.! !

!PUUser methodsFor: 'accessing-readonly' stamp: 'lr 12/20/2005 12:52'!
groups
	^ groups! !

!PUUser methodsFor: 'initialization' stamp: 'lr 2/20/2006 16:40'!
initialize
	super initialize.
	groups := OrderedCollection new.
	superuser := false.! !

!PUUser methodsFor: 'testing' stamp: 'lr 1/5/2006 11:35'!
isSuperuser
	^ self superuser.! !

!PUUser methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:35'!
password
	^ String new: 10 withAll: $*.! !

!PUUser methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:39'!
password: aString
	password := PRCompatibility hashPassword: aString.! !

!PUUser methodsFor: 'utilties' stamp: 'lr 12/20/2005 14:53'!
removeGroup: aGroup
	self groups remove: aGroup.
	aGroup users remove: self.! !

!PUUser methodsFor: 'accessing' stamp: 'lr 1/5/2006 11:34'!
superuser
	^ superuser! !

!PUUser methodsFor: 'accessing' stamp: 'lr 1/5/2006 11:34'!
superuser: aBoolean
	superuser := aBoolean! !

!PUUser methodsFor: 'validating' stamp: 'lr 12/20/2005 12:22'!
validatePassword: aString
	^ aString isEmptyOrNil not
		and: [ (PRCompatibility hashPassword: aString) = password ].! !

!PRCommandTest methodsFor: '*pier-security-accessing' stamp: 'lr 2/20/2006 15:28'!
adminGroup
	^ self kernel adminGroup.! !

!PRCommandTest methodsFor: '*pier-security-accessing' stamp: 'lr 2/20/2006 15:28'!
adminUser
	^ self kernel adminUser.! !

!PRCommandTest methodsFor: '*pier-security-accessing' stamp: 'lr 2/20/2006 15:29'!
bloggerGroup
	^ self kernel groups
		detect: [ :each | each name = 'blogger' ]
		ifNone: [ self kernel groups add: self bloggerGroupInstance ].! !

!PRCommandTest methodsFor: '*pier-security-private' stamp: 'lr 2/20/2006 15:30'!
bloggerGroupInstance
	^ PUGroup named: 'blogger'.! !

!PRCommandTest methodsFor: '*pier-security-accessing' stamp: 'lr 2/20/2006 15:29'!
bloggerUser
	^ self kernel users
		detect: [ :each | each name = 'james' ]
		ifNone: [ self kernel users add: self bloggerUserInstance ].! !

!PRCommandTest methodsFor: '*pier-security-private' stamp: 'lr 2/20/2006 15:30'!
bloggerUserInstance
	^ (PUUser named: 'james')
		addGroup: self bloggerGroup;
		password: 'bottom';
		yourself.! !

PRCommandTest subclass: #PUChangeSecurityTest
	instanceVariableNames: 'child hidden'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Tests'!

PUChangeSecurityTest subclass: #PUChangeGroupTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Tests'!

!PUChangeGroupTest class methodsFor: 'testing' stamp: 'lr 2/20/2006 13:03'!
isAbstract
	^ false! !

!PUChangeGroupTest methodsFor: 'private' stamp: 'lr 2/20/2006 13:04'!
actualClass
	^ PUChangeGroup! !

!PUChangeGroupTest methodsFor: 'testing' stamp: 'lr 2/20/2006 17:33'!
testGroup
	self command
		with: true; all: true; hidden: true;
		group: self bloggerGroup.
	self command execute.

	self assert: self structure group = self bloggerGroup.
	self assert: self hidden group = self bloggerGroup. 
	self assert: self child group = self bloggerGroup.! !

PUChangeSecurityTest subclass: #PUChangeOtherTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Tests'!

!PUChangeOtherTest class methodsFor: 'testing' stamp: 'lr 2/20/2006 13:03'!
isAbstract
	^ false! !

!PUChangeOtherTest methodsFor: 'private' stamp: 'lr 2/20/2006 13:04'!
actualClass
	^ PUChangeOther! !

PUChangeSecurityTest subclass: #PUChangeOwnerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Tests'!

!PUChangeOwnerTest class methodsFor: 'as yet unclassified' stamp: 'lr 2/20/2006 13:03'!
isAbstract
	^ false! !

!PUChangeOwnerTest methodsFor: 'private' stamp: 'lr 2/20/2006 13:04'!
actualClass
	^ PUChangeOwner! !

!PUChangeOwnerTest methodsFor: 'testing' stamp: 'lr 2/20/2006 17:32'!
testOwner
	self command
		with: true; all: true; hidden: true;
		owner: self bloggerUser.
	self command execute.

	self assert: self structure owner = self bloggerUser.
	self assert: self hidden owner = self bloggerUser. 
	self assert: self child owner = self bloggerUser.! !

!PUChangeSecurityTest methodsFor: 'private' stamp: 'lr 2/20/2006 17:21'!
actualClass
	^ PUChangeSecurity! !

!PUChangeSecurityTest methodsFor: 'accessing' stamp: 'lr 2/20/2006 16:57'!
child
	^ child ifNil: [ child := self childInstance ].! !

!PUChangeSecurityTest methodsFor: 'private' stamp: 'lr 2/20/2006 14:29'!
childInstance
	^ PRPage named: 'child'.! !

!PUChangeSecurityTest methodsFor: 'accessing' stamp: 'lr 2/20/2006 16:57'!
hidden
	^ hidden ifNil: [ hidden := self hiddenInstance ].! !

!PUChangeSecurityTest methodsFor: 'private' stamp: 'lr 2/20/2006 14:29'!
hiddenInstance
	^ (PRPage named: 'hidden')
		addDecoration: PRHider new;
		yourself.! !

!PUChangeSecurityTest methodsFor: 'accessing' stamp: 'lr 2/20/2006 17:12'!
permissions
	^ Set with: PRAddCommand with: PRRemoveCommand.! !

!PUChangeSecurityTest methodsFor: 'private' stamp: 'lr 2/20/2006 14:47'!
structureInstance
	^ super structureInstance
		addChild: self child;
		addChild: self hidden;
		yourself.! !

!PUChangeSecurityTest methodsFor: 'testing-operations' stamp: 'lr 2/20/2006 17:17'!
testOperationAdd
	self command
		with: true; all: true; hidden: true;
		operator: #add; permissions: self permissions.
	self command execute.

	self assert: ((self command accessor read: self structure) 
		includesAllOf: self permissions).
	self assert: ((self command accessor read: self hidden) 
		includesAllOf: self permissions).
	self assert: ((self command accessor read: self child) 
		includesAllOf: self permissions).! !

!PUChangeSecurityTest methodsFor: 'testing-operations' stamp: 'lr 2/20/2006 17:17'!
testOperationRemove
	self command
		with: true; all: true; hidden: true;
		operator: #remove; permissions: self permissions.
	self command execute.

	self deny: ((self command accessor read: self structure) 
		includesAnyOf: self permissions).
	self deny: ((self command accessor read: self hidden) 
		includesAnyOf: self permissions).
	self deny: ((self command accessor read: self child) 
		includesAnyOf: self permissions).! !

!PUChangeSecurityTest methodsFor: 'testing-operations' stamp: 'lr 2/20/2006 17:18'!
testOperationSet
	self command
		with: true; all: true; hidden: true;
		operator: #set; permissions: self permissions.
	self command execute.

	self assert: (self command accessor read: self structure) 
		= self permissions.
	self assert: (self command accessor read: self hidden)
		= self permissions.
	self assert: (self command accessor read: self child)
		= self permissions.! !

!PUChangeSecurityTest methodsFor: 'testing-operations' stamp: 'lr 2/20/2006 17:19'!
testOperationUnchanged
	| structurePermission hiddenPermissions childPermissions |
	structurePermission := (self command accessor read: self structure)
		copy.
	hiddenPermissions := (self command accessor read: self hidden)
		copy.
	childPermissions := (self command accessor read: self child)
		copy.

	self command
		with: true; all: true; hidden: true;
		operator: nil; permissions: self permissions.
	self command execute.

	self assert: (self command accessor 
		read: self structure) = structurePermission.
	self assert: (self command accessor 
		read: self hidden) = hiddenPermissions.
	self assert: (self command accessor 
		read: self child) = childPermissions.! !

PRCommandTest subclass: #PULoginTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Tests'!

!PULoginTest class methodsFor: 'testing' stamp: 'lr 2/20/2006 13:02'!
isAbstract
	^ false! !

!PULoginTest methodsFor: 'private' stamp: 'lr 2/20/2006 13:04'!
actualClass
	^ PULogin! !

!PULoginTest methodsFor: 'testing-testing' stamp: 'lr 2/20/2006 13:06'!
testIsLogged
	self deny: self command isLogged.! !

!PULoginTest methodsFor: 'testing' stamp: 'lr 2/20/2006 16:51'!
testLoginAdmin
	self assert: self command context user isNil.
	self command 
		username: self adminUser name;
		password: 'pier'.
	self 
		shouldnt: [ self command execute ]
		raise: PUInvalidLogin.
	self assert: self command user = self adminUser.
	self assert: self command answer user = self adminUser.
	self assert: self command context user isNil.! !

!PULoginTest methodsFor: 'testing' stamp: 'lr 2/20/2006 16:51'!
testLoginBlogger
	self assert: self command context user isNil.
	self command 
		username: self bloggerUser name;
		password: 'bottom'.
	self 
		shouldnt: [ self command execute ]
		raise: PUInvalidLogin.
	self assert: self command user = self bloggerUser.
	self assert: self command answer user = self bloggerUser.
	self assert: self command context user isNil.! !

!PULoginTest methodsFor: 'testing' stamp: 'lr 2/20/2006 16:51'!
testLoginInvalidPassword
	self assert: self command context user isNil.
	self command username: self bloggerUser name.
	self should: [ self command execute ] raise: PUInvalidLogin.
	self assert: self command context user isNil.! !

!PULoginTest methodsFor: 'testing' stamp: 'lr 2/20/2006 16:51'!
testLoginInvalidUsername
	self assert: self command context user isNil.
	self should: [ self command execute ] raise: PUInvalidLogin.
	self assert: self command context user isNil.! !

PRCommandTest subclass: #PULogoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Tests'!

!PULogoutTest class methodsFor: 'testing' stamp: 'lr 2/20/2006 13:02'!
isAbstract
	^ false! !

!PULogoutTest methodsFor: 'private' stamp: 'lr 2/20/2006 13:05'!
actualClass
	^ PULogout! !

!PULogoutTest methodsFor: 'private' stamp: 'lr 2/20/2006 15:35'!
contextInstance
	^ super contextInstance user: self bloggerUser.! !

!PULogoutTest methodsFor: 'testing-testing' stamp: 'lr 2/20/2006 13:06'!
testIsLogged
	self deny: self command isLogged.! !

!PULogoutTest methodsFor: 'testing-testing' stamp: 'lr 2/20/2006 13:07'!
testIsQuick
	self assert: self command isQuick.! !

!PULogoutTest methodsFor: 'testing' stamp: 'lr 2/20/2006 16:51'!
testingLogout
	self assert: self command context user = self bloggerUser.
	self command execute.
	self assert: self command answer user isNil.
	self assert: self command context user = self bloggerUser.! !

!PRKernel methodsFor: '*pier-security-defaults' stamp: 'lr 2/20/2006 15:26'!
adminGroup
	^ self propertyAt: #adminGroup ifAbsentPut: [ PUGroup named: 'admin' ].! !

!PRKernel methodsFor: '*pier-security-defaults' stamp: 'lr 2/20/2006 15:25'!
adminUser
	^ self propertyAt: #adminUser ifAbsentPut: [
		(PUUser named: 'admin')
			addGroup: self adminGroup;
			password: 'pier';
			superuser: true;
			yourself ].! !

!PRKernel methodsFor: '*pier-security-accessing' stamp: 'lr 2/20/2006 16:49'!
groups
	^ self propertyAt: #groups ifAbsentPut: [ Set with: self adminGroup ].! !

!PRKernel methodsFor: '*pier-security-accessing' stamp: 'lr 2/20/2006 16:49'!
users
	^ self propertyAt: #users ifAbsentPut: [ Set with: self adminUser ].! !

MAError subclass: #PUInvalidLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!
